# FlxQTL.jl

A package for a *Fl*e*x*ible multivariate linear mixed model (MLMM) suitable for *QTL (Quantitative Trait Loci)* analysis of
structured multivariate traits. 

## Package Features

- Genome scan (1D, 2D) for univariate, multivariate trait(s), and genotype (probability) data
- LOCO (Leave One Chromosome Out) support for genome scan 
- Computation for Genetic (or Climatic) Relatedness matrix (or kinship) 
- CPU parallelization
<!-- - Visualization (1D, 2D plots) -->

## Guide

```@contents
Pages = ["guide/tutorial.md",
        "guide/analysis.md",   
        ]
Depth = 1

```

## Manual

The descriptions of functions and types arranged by module.

```@contents
Pages = ["functions.md"]

```

## Index


```@index
Pages = ["functions.md"]
```